package k2;

import java.util.*;

/** Create a Knob that simulates a K2 "keyer" knob.  This currently has a
 * weakness in that the keyer speed is immediately set to whereever the
 * clickpoint is on the knob.  It would be better if a click and turn of the
 * knob adjusted keying speed relative to its initial position.  Shouldn't be
 * hard to do...
 *
 * <p>Mike Markowski, ab3ap@arrl.net<br>
 * March 2007
 */

public class KnobKeyer extends Knob {

	/** Create a KnobKeyer with specified center and radius, in pixels. */
	KnobKeyer(int cx, int cy, int r) {
		super();
		ctrX = cx;
		ctrY = cy;
		radius = r;
	}

	/** Generates the text string needed by the K2 to execute a keyer speed
	change.  */
	public String getK2Command() {
		return String.format("KS%03d;", (int) setting);
	}

}
