package k2;

/** Create a K2 power knob.  The knob is modeled to run from 0W to 110W.
 * This is wrong!!  It must be changed to detect whether a 100W power is
 * turned on or not.  If not, it should of course run from 0W to 15W.
 *
 * <p>Mike Markowski, ab3ap@arrl.net<br>
 * March 2007
 */

public class KnobPower extends Knob {

	private boolean isPAon = false;
	private String lastCmd = null;

	/** Make knob and specify its center and radius in units of pixels. */
	KnobPower(int cx, int cy, int r) {
		ctrX = cx;
		ctrY = cy;
		radius = r;
	}

	public void setPAState(boolean state) { isPAon = state; }

	/** Get K2 command that will set power to what user requested. */
	public String getK2Command() {

		char lohi;
		int settingInt;
		if (isPAon && setting >= 10.0) {
			lohi = '1';
			settingInt = (int) setting;
		} else {
			lohi = '0';
			settingInt = (int) (10 * setting);
		}
		lastCmd = String.format("PC%03d%c;", settingInt, lohi);
		return lastCmd;
	}

}
