package k2;

/** Create a K2 VFO tuning knob.  It's modeled to have 100 discrete
 * steps per knob revolution.  This should be reduced to 15 per revpolution
 * when in edit mode, but currently is not.  (Please fix me!)
 *
 * <p>Mike Markowski, ab3ap@arrl.net<br>
 * March 2007
 */

public class KnobVFO extends Knob {

	/** Make knob with requested center point and radius in units of pixels. */
	KnobVFO(int cx, int cy, int r) {
		ctrX = cx;
		ctrY = cy;
		radius = r;
	}

	/** Get K2 command to tun by current increment of 10, 100, or 1000 Hz. */
	public String getK2Command(boolean tens, boolean hundreds) {

		char stepSize;
		if (tens)
			stepSize = '1'; // 10 Hz steps.
		else if (hundreds)
			stepSize = '3'; // 50 Hz steps.
		else
			stepSize = '4'; // 1 kHz steps.

		String cmd;
		if (getTurningDir() == 1)
			cmd = "UP";
		else
			cmd = "DN";
		cmd += stepSize + ";";

		return cmd;
	}

}
