/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package k3eq;

import java.awt.Dimension;
import java.awt.Toolkit;
import javax.swing.*;
import util.Serial;

/**
 *
 * @author mm
 */
public class UI extends javax.swing.JFrame {

    boolean tx;
    boolean readingK3;
    JLabel label[];
    JSlider slider[];
    Serial sport;

    /**
     * Creates new form UI
     */
    public UI() {
        initComponents();
        tx = ssbRadioButton.isSelected();
        slider = new JSlider[8];
        slider[0] = aSlider;
        slider[1] = bSlider;
        slider[2] = cSlider;
        slider[3] = dSlider;
        slider[4] = eSlider;
        slider[5] = fSlider;
        slider[6] = gSlider;
        slider[7] = hSlider;
        label = new JLabel[8];
        label[0] = aLabel;
        label[1] = bLabel;
        label[2] = cLabel;
        label[3] = dLabel;
        label[4] = eLabel;
        label[5] = fLabel;
        label[6] = gLabel;
        label[7] = hLabel;
        setTitle("AB3AP K3 EQ");
        Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
        // Center panel on screen.
        setLocation(((int) dim.getWidth() - getWidth()) / 2,
                ((int) dim.getHeight() - getHeight()) / 2);
        sport = new Serial();
        uiEnable(false);
        mkPortComboBoxes();
//        if (sport.findK3()) {
//            uiEnable(true);
//        } else {
//            JOptionPane.showMessageDialog(this,
//                    "Cannot find K3.  Is it on and connected to serial port?",
//                    "K3 discovery error",
//                    JOptionPane.ERROR_MESSAGE);
//            System.exit(1);
//        }
    }

    private void uiEnable(boolean enable) {
        ssbRadioButton.setEnabled(enable);
        wideRadioButton.setEnabled(enable);
        rxRadioButton.setEnabled(enable);
        zeroButton.setEnabled(enable);
        for (int i = 0; i < 8; i++) {
            slider[i].setEnabled(enable);
        }
    }

    public void setSport(Serial sport) {
        this.sport = sport;
    }

    private void setupEq() {
        readingK3 = true;
        // Go to tx or rx EQ menu.
        sport.serialWrite(tx ? "MN009;" : "MN008;", 100);
        // Set sliders based on current K3 EQ settings.
        for (int i = 0; i < 8; i++) {
            int dB = dBfromK3Slider(i); // Get K3 setting.
            slider[i].setValue(dB);
            String dBstr = String.format("%+d", dB);
            label[i].setText(dBstr);
        }

        // Exit MENU mode.
        sport.serialWrite("SWT14;", 100);
        readingK3 = false;
    }

    private int dBfromK3Slider(int sliderNum) {
        byte[] response = new byte[12];
        // Get K3 button number corresponding to digit '1' through '8'.
        int buttonNum = buttonIndexToNum(sliderNum);
        int val = 0;
        // Make several attempts, if necessary, to retrieve EQ setting.
        for (int attempt = 0; attempt < 10; attempt++) {
            // Tap numeral button, 1 through 8, for sliderNum's equalizer band.
            String cmd = String.format("SWT%2d;", buttonNum);
            // Get EQ info from VFO B text area.
            sport.serialWrite(cmd, 15); // Send button tap command for band.
            sport.serialWrite("DB;", 50); // Send cmd to get VFO B text area.
            sport.serialRead(response); // Retrieve K3's answer.
            String s = new String(response, 2, 10);
            int start = 1 + s.lastIndexOf('+');
            if (start <= 0) {
                start = s.lastIndexOf('-');
            }
            int semi = s.indexOf(';');
            if (start < 0 || semi < 0 || start > semi) {
                continue; // Bad response, try again.
            }
            String dB = s.substring(start, semi);
            try {
                val = Integer.valueOf(dB);
            } catch (NumberFormatException e) {
                continue;
            }
            break;
        }
        return val;
    }

    private void mkPortComboBoxes() {

        DefaultComboBoxModel m = new DefaultComboBoxModel();
        m.addElement("Select serial port.");

        String[] ports = sport.getSerialPortNames();
        for (int i = 0; i < ports.length; i++) {
            m.addElement(ports[i]);
        }
        portComboBox.setModel(m);
    }

    private int sliderIndex(JSlider s) {
        if (s == aSlider) {
            return 0;
        }
        if (s == bSlider) {
            return 1;
        }
        if (s == cSlider) {
            return 2;
        }
        if (s == dSlider) {
            return 3;
        }
        if (s == eSlider) {
            return 4;
        }
        if (s == fSlider) {
            return 5;
        }
        if (s == gSlider) {
            return 6;
        }
        if (s == hSlider) {
            return 7;
        }
        return -1;
    }

    private int buttonIndexToNum(int i) {
        int buttonNum = -1;
        switch (i) {
            case 0:
                buttonNum = 11;
                break;
            case 1:
                buttonNum = 12;
                break;
            case 2:
                buttonNum = 13;
                break;
            case 3:
                buttonNum = 24;
                break;
            case 4:
                buttonNum = 27;
                break;
            case 5:
                buttonNum = 29;
                break;
            case 6:
                buttonNum = 33;
                break;
            case 7:
                buttonNum = 34;
                break;
        }
        return buttonNum;
    }

    private void setEq(int sliderIndex, int dBnew) {

        readingK3 = true;

        if (tx) {
            String cmd = "TE";
            for (int i = 0; i < 8; i++) {
                cmd += String.format("%+03d", slider[i].getValue());
            }
            cmd += ";";
//            System.out.println("cmd = '" + cmd + "'");
            sport.serialWrite(cmd, 10);
        } else {
            // Go to RX EQ menu.
            sport.serialWrite("MN008;", 100);
            // Adjust each slider.
            int dB = dBfromK3Slider(sliderIndex);
            int delta = dBnew - dB;
            if (delta >= 0) {
                for (int i = 0; i < delta; i++) {
                    sport.serialWrite("UP;", 50);
                }
            } else {
                for (int i = 0; i < -delta; i++) {
                    sport.serialWrite("DN;", 50);
                }
            }
            // Exit MENU mode.
            sport.serialWrite("SWT14;", 100);
        }
        readingK3 = false;
    }

    private void zeroEq() {
        if (tx) {
            sport.serialWrite("TE+00+00+00+00+00+00+00+00;", 10);
            setEqUi(0, 0, 0, 0, 0, 0, 0, 0);
        } else {
            for (int i = 0; i < 8; i++) {
                slider[i].setValue(0);
                label[i].setText("+0");
                setEq(i, 0);
            }
        }
    }

    private void setEqUi(int b1, int b2, int b3, int b4,
            int b5, int b6, int b7, int b8) {
        slider[0].setValue(b1);
        label[0].setText(String.format("%+d", b1));
        slider[1].setValue(b2);
        label[1].setText(String.format("%+d", b2));
        slider[2].setValue(b3);
        label[2].setText(String.format("%+d", b3));
        slider[3].setValue(b4);
        label[3].setText(String.format("%+d", b4));
        slider[4].setValue(b5);
        label[4].setText(String.format("%+d", b5));
        slider[5].setValue(b6);
        label[5].setText(String.format("%+d", b6));
        slider[6].setValue(b7);
        label[6].setText(String.format("%+d", b7));
        slider[7].setValue(b8);
        label[7].setText(String.format("%+d", b8));
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        txRxButtonGroup = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        ssbRadioButton = new javax.swing.JRadioButton();
        rxRadioButton = new javax.swing.JRadioButton();
        wideRadioButton = new javax.swing.JRadioButton();
        jPanel2 = new javax.swing.JPanel();
        jLabel13 = new javax.swing.JLabel();
        aSlider = new javax.swing.JSlider();
        jLabel9 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        bSlider = new javax.swing.JSlider();
        dLabel = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        fSlider = new javax.swing.JSlider();
        gLabel = new javax.swing.JLabel();
        bLabel = new javax.swing.JLabel();
        cSlider = new javax.swing.JSlider();
        eLabel = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        cLabel = new javax.swing.JLabel();
        aLabel = new javax.swing.JLabel();
        hSlider = new javax.swing.JSlider();
        jLabel2 = new javax.swing.JLabel();
        hLabel = new javax.swing.JLabel();
        eSlider = new javax.swing.JSlider();
        jLabel3 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        dSlider = new javax.swing.JSlider();
        fLabel = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        gSlider = new javax.swing.JSlider();
        jLabel6 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        zeroButton = new javax.swing.JButton();
        exitButton = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        portComboBox = new javax.swing.JComboBox();
        jPanel3 = new javax.swing.JPanel();
        presetComboBox = new javax.swing.JComboBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                windowCLosingHandler(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Audio EQ"));

        txRxButtonGroup.add(ssbRadioButton);
        ssbRadioButton.setText("Tx SSB");
        ssbRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioButtonHandler(evt);
            }
        });

        txRxButtonGroup.add(rxRadioButton);
        rxRadioButton.setSelected(true);
        rxRadioButton.setText("Rx");
        rxRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioButtonHandler(evt);
            }
        });

        txRxButtonGroup.add(wideRadioButton);
        wideRadioButton.setText("Tx Wide");
        wideRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioButtonHandler(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(rxRadioButton)
            .addComponent(ssbRadioButton)
            .addComponent(wideRadioButton)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(rxRadioButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(ssbRadioButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(wideRadioButton))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Equalizer"));

        jLabel13.setFont(new java.awt.Font("DejaVu Sans", 1, 16)); // NOI18N
        jLabel13.setText("dB");

        aSlider.setMajorTickSpacing(4);
        aSlider.setMaximum(16);
        aSlider.setMinimum(-16);
        aSlider.setMinorTickSpacing(1);
        aSlider.setOrientation(javax.swing.JSlider.VERTICAL);
        aSlider.setPaintTicks(true);
        aSlider.setSnapToTicks(true);
        aSlider.setValue(0);
        aSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sliderHandler(evt);
            }
        });

        jLabel9.setText("50");

        jLabel12.setFont(new java.awt.Font("DejaVu Sans", 1, 16)); // NOI18N
        jLabel12.setText("Hz");

        bSlider.setMajorTickSpacing(4);
        bSlider.setMaximum(16);
        bSlider.setMinimum(-16);
        bSlider.setMinorTickSpacing(1);
        bSlider.setOrientation(javax.swing.JSlider.VERTICAL);
        bSlider.setPaintTicks(true);
        bSlider.setSnapToTicks(true);
        bSlider.setValue(0);
        bSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sliderHandler(evt);
            }
        });

        dLabel.setText("000");
        dLabel.setFocusable(false);

        jLabel4.setText("400");

        fSlider.setMajorTickSpacing(4);
        fSlider.setMaximum(16);
        fSlider.setMinimum(-16);
        fSlider.setMinorTickSpacing(1);
        fSlider.setOrientation(javax.swing.JSlider.VERTICAL);
        fSlider.setPaintTicks(true);
        fSlider.setSnapToTicks(true);
        fSlider.setValue(0);
        fSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sliderHandler(evt);
            }
        });

        gLabel.setText("000");
        gLabel.setFocusable(false);

        bLabel.setText("000");
        bLabel.setFocusable(false);

        cSlider.setMajorTickSpacing(4);
        cSlider.setMaximum(16);
        cSlider.setMinimum(-16);
        cSlider.setMinorTickSpacing(1);
        cSlider.setOrientation(javax.swing.JSlider.VERTICAL);
        cSlider.setPaintTicks(true);
        cSlider.setSnapToTicks(true);
        cSlider.setValue(0);
        cSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sliderHandler(evt);
            }
        });

        eLabel.setText("000");
        eLabel.setFocusable(false);

        jLabel7.setText("2400");

        cLabel.setText("000");
        cLabel.setFocusable(false);

        aLabel.setText("000");
        aLabel.setFocusable(false);

        hSlider.setMajorTickSpacing(4);
        hSlider.setMaximum(16);
        hSlider.setMinimum(-16);
        hSlider.setMinorTickSpacing(1);
        hSlider.setOrientation(javax.swing.JSlider.VERTICAL);
        hSlider.setPaintTicks(true);
        hSlider.setSnapToTicks(true);
        hSlider.setValue(0);
        hSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sliderHandler(evt);
            }
        });

        jLabel2.setText("100");

        hLabel.setText("000");
        hLabel.setFocusable(false);

        eSlider.setMajorTickSpacing(4);
        eSlider.setMaximum(16);
        eSlider.setMinimum(-16);
        eSlider.setMinorTickSpacing(1);
        eSlider.setOrientation(javax.swing.JSlider.VERTICAL);
        eSlider.setPaintTicks(true);
        eSlider.setSnapToTicks(true);
        eSlider.setValue(0);
        eSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sliderHandler(evt);
            }
        });

        jLabel3.setText("200");

        jLabel10.setFont(new java.awt.Font("DejaVu Sans", 1, 16)); // NOI18N
        jLabel10.setText("-16 dB");

        dSlider.setMajorTickSpacing(4);
        dSlider.setMaximum(16);
        dSlider.setMinimum(-16);
        dSlider.setMinorTickSpacing(1);
        dSlider.setOrientation(javax.swing.JSlider.VERTICAL);
        dSlider.setPaintTicks(true);
        dSlider.setSnapToTicks(true);
        dSlider.setValue(0);
        dSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sliderHandler(evt);
            }
        });

        fLabel.setText("000");
        fLabel.setFocusable(false);

        jLabel5.setText("800");

        jLabel8.setText("3200");

        gSlider.setMajorTickSpacing(4);
        gSlider.setMaximum(16);
        gSlider.setMinimum(-16);
        gSlider.setMinorTickSpacing(1);
        gSlider.setOrientation(javax.swing.JSlider.VERTICAL);
        gSlider.setPaintTicks(true);
        gSlider.setSnapToTicks(true);
        gSlider.setValue(0);
        gSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sliderHandler(evt);
            }
        });

        jLabel6.setText("1600");

        jLabel1.setFont(new java.awt.Font("DejaVu Sans", 1, 16)); // NOI18N
        jLabel1.setText("+16 dB");

        zeroButton.setFont(new java.awt.Font("DejaVu LGC Sans", 1, 16)); // NOI18N
        zeroButton.setText("0 dB");
        zeroButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHandler(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(aLabel)
                    .addComponent(aSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(bSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2)
                    .addComponent(bLabel))
                .addGap(18, 18, 18)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(cSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3)
                    .addComponent(cLabel))
                .addGap(18, 18, 18)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(dSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4)
                    .addComponent(dLabel))
                .addGap(18, 18, 18)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(eSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5)
                    .addComponent(eLabel))
                .addGap(18, 18, 18)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(fSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6)
                    .addComponent(fLabel))
                .addGap(18, 18, 18)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(gSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7)
                    .addComponent(gLabel))
                .addGap(18, 18, 18)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(hSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel8)
                    .addComponent(hLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jLabel10)
                    .addComponent(zeroButton)))
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(215, 215, 215)
                .addComponent(jLabel12))
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(216, 216, 216)
                .addComponent(jLabel13))
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(12, 12, 12)
                .addComponent(jLabel9))
        );

        jPanel2Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {aSlider, bSlider, cSlider, dSlider, eSlider, fSlider, gSlider, hSlider, jLabel2, jLabel3, jLabel4, jLabel5, jLabel6, jLabel7, jLabel8});

        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(21, 21, 21)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(aLabel)
                            .addComponent(bLabel)
                            .addComponent(cLabel)
                            .addComponent(dLabel)
                            .addComponent(eLabel)
                            .addComponent(fLabel)
                            .addComponent(gLabel)
                            .addComponent(hLabel))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabel13)
                        .addGap(27, 27, 27)))
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(fSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(eSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(dSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(bSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(cSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGap(206, 206, 206)
                                .addComponent(jLabel3)))
                        .addGroup(jPanel2Layout.createSequentialGroup()
                            .addComponent(aSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jLabel2)
                                .addComponent(jLabel9))))
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(gSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addGroup(jPanel2Layout.createSequentialGroup()
                                        .addComponent(jLabel1)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(zeroButton)
                                        .addGap(64, 64, 64)
                                        .addComponent(jLabel10))
                                    .addComponent(hSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(jLabel7)
                                    .addComponent(jLabel8))))
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel4)
                            .addComponent(jLabel5)
                            .addComponent(jLabel6))))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel12)
                .addContainerGap())
        );

        exitButton.setText("Exit");
        exitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHandler(evt);
            }
        });

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Serial Port"));

        portComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                comboHandler(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addComponent(portComboBox, 0, 183, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(portComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Presets"));

        presetComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Choose preset...", "Flat (all)", "Joe W4TV (Tx SSB)" }));
        presetComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                comboHandler(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(presetComboBox, 0, 186, Short.MAX_VALUE)
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addComponent(presetComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 6, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(exitButton, javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(6, 6, 6)))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(jPanel3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jPanel4, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(exitButton)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void radioButtonHandler(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioButtonHandler
        JRadioButton b = (JRadioButton) evt.getSource();
        tx = (b != rxRadioButton);
        if (sport == null) {
            return;
        }
        if (b == ssbRadioButton) {
            sport.serialWrite("MD2;", 1000); // USB
        } else if (b == wideRadioButton) {
            sport.serialWrite("MD5;", 1000); // AM
        }
        setupEq();
    }//GEN-LAST:event_radioButtonHandler

    private void buttonHandler(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHandler
        JButton b = (JButton) evt.getSource();
        if (b == exitButton) {
            sport.close();
            dispose();
            System.exit(0);
        } else if (b == zeroButton) {
            zeroEq();
        }
    }//GEN-LAST:event_buttonHandler

    private void windowCLosingHandler(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_windowCLosingHandler
        sport.close();
        dispose();
        System.exit(0);
    }//GEN-LAST:event_windowCLosingHandler

    private void sliderHandler(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_sliderHandler
        if (readingK3) {
            return;
        }
        JSlider s = (JSlider) evt.getSource();
        int si = sliderIndex(s);
        label[si].setText(String.format("%+3d", s.getValue()));
        if (s.getValueIsAdjusting()) {
            return;
        }
        // Send command to K3 to adjust EQ.
        setEq(si, s.getValue());
    }//GEN-LAST:event_sliderHandler

    private void comboHandler(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_comboHandler
        JComboBox cb = (JComboBox) evt.getSource();
        String item = (String) cb.getSelectedItem();
        if (cb == portComboBox) {
            if (!sport.setSerialPort("K3", item)) {
                JOptionPane.showMessageDialog(this,
                        "Can't open port " + item + ".",
                        "K3 serial port error",
                        JOptionPane.ERROR_MESSAGE);
                System.exit(1);
            } else {
                setupEq();
                uiEnable(true);
            }
        } else if (cb == presetComboBox && cb.getSelectedIndex() == 1) {
            zeroEq();
            cb.setSelectedIndex(0);
        } else if (cb == presetComboBox && cb.getSelectedIndex() == 2) {
            if (tx) {
                sport.serialWrite("TE-16-06-03+00+00+03+05+00;", 10);
                setEqUi(-16, -6, -3, 0, 0, 3, 5, 0);
                cb.setSelectedIndex(0);
            }
        }
    }//GEN-LAST:event_comboHandler

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /*
         * Set the Nimbus look and feel
         */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /*
         * If Nimbus (introduced in Java SE 6) is not available, stay with the
         * default look and feel. For details see
         * http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info :
                    javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(UI.class.getName()).log(
                    java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(UI.class.getName()).log(
                    java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(UI.class.getName()).log(
                    java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(UI.class.getName()).log(
                    java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /*
         * Create and display the form
         */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new UI().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel aLabel;
    private javax.swing.JSlider aSlider;
    private javax.swing.JLabel bLabel;
    private javax.swing.JSlider bSlider;
    private javax.swing.JLabel cLabel;
    private javax.swing.JSlider cSlider;
    private javax.swing.JLabel dLabel;
    private javax.swing.JSlider dSlider;
    private javax.swing.JLabel eLabel;
    private javax.swing.JSlider eSlider;
    private javax.swing.JButton exitButton;
    private javax.swing.JLabel fLabel;
    private javax.swing.JSlider fSlider;
    private javax.swing.JLabel gLabel;
    private javax.swing.JSlider gSlider;
    private javax.swing.JLabel hLabel;
    private javax.swing.JSlider hSlider;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JComboBox portComboBox;
    private javax.swing.JComboBox presetComboBox;
    private javax.swing.JRadioButton rxRadioButton;
    private javax.swing.JRadioButton ssbRadioButton;
    private javax.swing.ButtonGroup txRxButtonGroup;
    private javax.swing.JRadioButton wideRadioButton;
    private javax.swing.JButton zeroButton;
    // End of variables declaration//GEN-END:variables
}
